﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using Tsi1.BusinessLayer.Dtos;
using Tsi1.BusinessLayer.Helpers;

namespace Tsi1.BusinessLayer.Interfaces
{
    public interface IEvaluationService
    {
        Task<ServiceResult<bool>> Registration(int evaluationId, int userId);

        Task<ServiceResult<bool>> CancelRegistration(int evaluationId, int userId);

        Task<ServiceResult<bool>> SubmitLaboratory(FileDto fileDto, int evaluationId, int userId);

        Task<ServiceResult<bool>> DeleteLaboratory(int submissionId, int userId);

        Task<ServiceResult<List<MyEvaluationInscriptionDto>>> GetMyEvaluationInscriptions(int userId, int courseId);

        Task<ServiceResult<List<EvaluationInscriptionDto>>> GetAllEvaluationInscriptions(int userId, int evaluationId);

        Task<ServiceResult<bool>> QualifyEvaluationInscription(EvaluationInscriptionModifyDto evaluationInscriptionDto, int userId);
    }
}
