﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;
using System;
using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using Tsi1.DataLayer.Entities;

namespace Tsi1.DataLayer.EntityConfiguration
{
    class PostMessageConfiguration : IEntityTypeConfiguration<PostMessage>
    {
        public void Configure(EntityTypeBuilder<PostMessage> builder)
        {
            builder.HasKey(x => x.Id);

            builder.Property(x => x.Content)
                .IsRequired()
                .HasColumnType("character varying(10485760)");

            builder.HasOne(x => x.User)
                .WithMany(x => x.PostMessages)
                .HasForeignKey(x => x.UserId);

            builder.HasOne(x => x.Post)
                .WithMany(x => x.PostMessages)
                .HasForeignKey(x => x.PostId);

        }
    }
}
